<template>
  <!-- table.pt-posts>(thead.-thead>tr.-tr>th.-th*5{test1})+(tbody.-tbody>tr.-tr>td.-td) -->
  <table class="pt-posts" @click="editPost">
    <thead class="pt-posts__thead">
      <tr class="pt-posts__tr">
        <th class="pt-posts__th">№</th>
        <th class="pt-posts__th">Заголовок</th>
        <th class="pt-posts__th">Количество слов</th>
        <th class="pt-posts__th">Количество букв</th>
        <th class="pt-posts__th"></th>
      </tr>
    </thead>
    <tbody class="pt-posts__tbody">
      <template v-for="post in postsUserFilter" :key="post.id">
        <tr class="pt-posts__tr">
          <td class="pt-posts__td">{{ post.id }}</td>
          <td class="pt-posts__td">{{ post.title }}</td>
          <td class="pt-posts__td">{{ sumWords(post.body) }}</td>
          <td class="pt-posts__td">{{ sumChars(post.body) }}</td>
          <td class="pt-posts__td">
            <button @click="editPostTrigger(post.id, post.title, post.body)">
              Редактировать
            </button>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
</template>

<script setup>
import { ref, computed } from "vue";

const props = defineProps({
  user: {
    type: Number,
    required: true,
    default: 0,
  },
});
const emit = defineEmits(["editPost"]);

// получение данных о постах для таблицы
const responseUrl = "https://jsonplaceholder.typicode.com/posts";
let responseData = ref([]);

fetch(responseUrl)
  .then((response) => response.json())
  .then((json) => (responseData.value = json));

const postsUserFilter = computed(() =>
  responseData.value.filter((item) => props.user === item.userId)
);

const editPostTrigger = (postID, postName, postBody) => {
  emit("editPost", { postID, postName, postBody });
};

const sumWords = (text) => {
  return text.split(" ").length;
};
const sumChars = (text) => {
  return text.length;
};
</script>

<style lang="less">
.pt-posts {
  min-width: 100%;
  padding: 10px 0;
  border: 1px solid;
}

.pt-posts__tbody > .pt-posts__tr {
  &:hover {
    background: rgba(0, 0, 255, 0.25);
  }
}

.pt-posts__td {
  padding: 5px;
}
</style>
